# graylog
No descripton provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.1.1+01d50e5
- Package version: 1.0.0
- Build date: 2016-09-23T11:06:39.572+08:00
- Build package: class io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/yumimobi/graylog.py.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/yumimobi/graylog.py.git`)

Then import the package:
```python
import graylog 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import graylog
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
import time
import graylog
from graylog.rest import ApiException
from pprint import pprint
# create an instance of the API class
api_instance = graylog.ApidocsApi

try:
    # Get API documentation
    api_instance.overview()
except ApiException as e:
    print "Exception when calling ApidocsApi->overview: %s\n" % e

```

## Documentation for API Endpoints

All URIs are relative to *http://log.ano.yumimobi.com/api*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ApidocsApi* | [**overview**](docs/ApidocsApi.md#overview) | **GET** /api-docs | Get API documentation
*ApidocsApi* | [**route**](docs/ApidocsApi.md#route) | **GET** /api-docs/{route: .+} | Get detailed API documentation of a single resource
*ClusterApi* | [**get**](docs/ClusterApi.md#get) | **GET** /cluster | Get system overview of all Graylog nodes
*ClusterApi* | [**jvm**](docs/ClusterApi.md#jvm) | **GET** /cluster/{nodeId}/jvm | Get JVM information of the given node
*ClusterApi* | [**thread_dump**](docs/ClusterApi.md#thread_dump) | **GET** /cluster/{nodeId}/threaddump | Get a thread dump of the given node
*ClusterdeflectorApi* | [**cycle**](docs/ClusterdeflectorApi.md#cycle) | **POST** /cluster/deflector/cycle | Finds master node and triggers deflector cycle
*ClusterinputstatesApi* | [**get**](docs/ClusterinputstatesApi.md#get) | **GET** /cluster/inputstates | Get all input states
*ClusterinputstatesApi* | [**start**](docs/ClusterinputstatesApi.md#start) | **PUT** /cluster/inputstates/{inputId} | Start or restart specified input in all nodes
*ClusterinputstatesApi* | [**stop**](docs/ClusterinputstatesApi.md#stop) | **DELETE** /cluster/inputstates/{inputId} | Stop specified input in all nodes
*ClusterjobsApi* | [**cancel_job**](docs/ClusterjobsApi.md#cancel_job) | **DELETE** /cluster/jobs/{jobId} | Cancel job with the given ID
*ClusterjobsApi* | [**get_job**](docs/ClusterjobsApi.md#get_job) | **GET** /cluster/jobs/{jobId} | Get job with the given ID
*ClusterjobsApi* | [**list**](docs/ClusterjobsApi.md#list) | **GET** /cluster/jobs | List currently running jobs
*ClustermetricsApi* | [**multiple_metrics_all_nodes**](docs/ClustermetricsApi.md#multiple_metrics_all_nodes) | **POST** /cluster/metrics/multiple | Get all metrics of all nodes in the cluster
*ClustersystemloggersApi* | [**loggers**](docs/ClustersystemloggersApi.md#loggers) | **GET** /cluster/system/loggers | List all loggers of all nodes and their current levels
*ClustersystemloggersApi* | [**set_subsystem_logger_level**](docs/ClustersystemloggersApi.md#set_subsystem_logger_level) | **PUT** /cluster/system/loggers/{nodeId}/subsystems/{subsystem}/level/{level} | Set the loglevel of a whole subsystem
*ClustersystemloggersApi* | [**subsystems**](docs/ClustersystemloggersApi.md#subsystems) | **GET** /cluster/system/loggers/subsystems | List all logger subsystems and their current levels
*CountApi* | [**total**](docs/CountApi.md#total) | **GET** /count/total | Total number of messages in all your indices.
*DashboardsApi* | [**create**](docs/DashboardsApi.md#create) | **POST** /dashboards | Create a dashboard
*DashboardsApi* | [**delete**](docs/DashboardsApi.md#delete) | **DELETE** /dashboards/{dashboardId} | Delete a dashboard and all its widgets
*DashboardsApi* | [**get**](docs/DashboardsApi.md#get) | **GET** /dashboards/{dashboardId} | Get a single dashboards and all configurations of its widgets.
*DashboardsApi* | [**list**](docs/DashboardsApi.md#list) | **GET** /dashboards | Get a list of all dashboards and all configurations of their widgets.
*DashboardsApi* | [**set_positions**](docs/DashboardsApi.md#set_positions) | **PUT** /dashboards/{dashboardId}/positions | Update/set the positions of dashboard widgets.
*DashboardsApi* | [**update**](docs/DashboardsApi.md#update) | **PUT** /dashboards/{dashboardId} | Update the settings of a dashboard.
*FiltersblacklistApi* | [**create**](docs/FiltersblacklistApi.md#create) | **POST** /filters/blacklist | Create a blacklist filter
*FiltersblacklistApi* | [**delete**](docs/FiltersblacklistApi.md#delete) | **DELETE** /filters/blacklist/{filterId} | Remove the existing blacklist filter
*FiltersblacklistApi* | [**get**](docs/FiltersblacklistApi.md#get) | **GET** /filters/blacklist/{filterId} | Get the existing blacklist filter
*FiltersblacklistApi* | [**get_all**](docs/FiltersblacklistApi.md#get_all) | **GET** /filters/blacklist | Get all blacklist filters
*FiltersblacklistApi* | [**update**](docs/FiltersblacklistApi.md#update) | **PUT** /filters/blacklist/{filterId} | Update an existing blacklist filter
*MessagesApi* | [**analyze**](docs/MessagesApi.md#analyze) | **GET** /messages/{index}/analyze | Analyze a message string
*MessagesApi* | [**parse**](docs/MessagesApi.md#parse) | **POST** /messages/parse | Parse a raw message
*MessagesApi* | [**search**](docs/MessagesApi.md#search) | **GET** /messages/{index}/{messageId} | Get a single message.
*PluginsorggraylogpluginscollectorApi* | [**copy_configuration**](docs/PluginsorggraylogpluginscollectorApi.md#copy_configuration) | **POST** /plugins/org.graylog.plugins.collector/configurations/{id}/{name} | Copy a configuration
*PluginsorggraylogpluginscollectorApi* | [**copy_input**](docs/PluginsorggraylogpluginscollectorApi.md#copy_input) | **POST** /plugins/org.graylog.plugins.collector/configurations/{id}/inputs/{inputId}/{name} | Copy a configuration input
*PluginsorggraylogpluginscollectorApi* | [**copy_output**](docs/PluginsorggraylogpluginscollectorApi.md#copy_output) | **POST** /plugins/org.graylog.plugins.collector/configurations/{id}/outputs/{outputId}/{name} | Copy a configuration output
*PluginsorggraylogpluginscollectorApi* | [**copy_snippet**](docs/PluginsorggraylogpluginscollectorApi.md#copy_snippet) | **POST** /plugins/org.graylog.plugins.collector/configurations/{id}/snippets/{snippetId}/{name} | Copy a configuration snippet
*PluginsorggraylogpluginscollectorApi* | [**create_configuration**](docs/PluginsorggraylogpluginscollectorApi.md#create_configuration) | **POST** /plugins/org.graylog.plugins.collector/configurations | Create new collector configuration
*PluginsorggraylogpluginscollectorApi* | [**create_input**](docs/PluginsorggraylogpluginscollectorApi.md#create_input) | **POST** /plugins/org.graylog.plugins.collector/configurations/{id}/inputs | Create a configuration input
*PluginsorggraylogpluginscollectorApi* | [**create_output**](docs/PluginsorggraylogpluginscollectorApi.md#create_output) | **POST** /plugins/org.graylog.plugins.collector/configurations/{id}/outputs | Create a configuration output
*PluginsorggraylogpluginscollectorApi* | [**create_snippet**](docs/PluginsorggraylogpluginscollectorApi.md#create_snippet) | **POST** /plugins/org.graylog.plugins.collector/configurations/{id}/snippets | Create a configuration snippet
*PluginsorggraylogpluginscollectorApi* | [**delete_configuration**](docs/PluginsorggraylogpluginscollectorApi.md#delete_configuration) | **DELETE** /plugins/org.graylog.plugins.collector/configurations/{id} | Delete a collector configuration
*PluginsorggraylogpluginscollectorApi* | [**delete_input**](docs/PluginsorggraylogpluginscollectorApi.md#delete_input) | **DELETE** /plugins/org.graylog.plugins.collector/configurations/{id}/inputs/{inputId} | Delete input form configuration
*PluginsorggraylogpluginscollectorApi* | [**delete_output**](docs/PluginsorggraylogpluginscollectorApi.md#delete_output) | **DELETE** /plugins/org.graylog.plugins.collector/configurations/{id}/outputs/{outputId} | Delete output from configuration
*PluginsorggraylogpluginscollectorApi* | [**delete_snippet**](docs/PluginsorggraylogpluginscollectorApi.md#delete_snippet) | **DELETE** /plugins/org.graylog.plugins.collector/configurations/{id}/snippets/{snippetId} | Delete snippet from configuration
*PluginsorggraylogpluginscollectorApi* | [**get_configuration**](docs/PluginsorggraylogpluginscollectorApi.md#get_configuration) | **GET** /plugins/org.graylog.plugins.collector/{collectorId} | Get a single collector configuration
*PluginsorggraylogpluginscollectorApi* | [**get_configurations**](docs/PluginsorggraylogpluginscollectorApi.md#get_configurations) | **GET** /plugins/org.graylog.plugins.collector/configurations/{id} | Show collector configuration details
*PluginsorggraylogpluginscollectorApi* | [**get_tags**](docs/PluginsorggraylogpluginscollectorApi.md#get_tags) | **GET** /plugins/org.graylog.plugins.collector/configurations/tags | List all used tags
*PluginsorggraylogpluginscollectorApi* | [**list_configurations**](docs/PluginsorggraylogpluginscollectorApi.md#list_configurations) | **GET** /plugins/org.graylog.plugins.collector/configurations | List all collector configurations
*PluginsorggraylogpluginscollectorApi* | [**update_configuration_name**](docs/PluginsorggraylogpluginscollectorApi.md#update_configuration_name) | **PUT** /plugins/org.graylog.plugins.collector/configurations/{id}/name | Updates a collector configuration name
*PluginsorggraylogpluginscollectorApi* | [**update_input**](docs/PluginsorggraylogpluginscollectorApi.md#update_input) | **PUT** /plugins/org.graylog.plugins.collector/configurations/{id}/inputs/{input_id} | Update a configuration input
*PluginsorggraylogpluginscollectorApi* | [**update_output**](docs/PluginsorggraylogpluginscollectorApi.md#update_output) | **PUT** /plugins/org.graylog.plugins.collector/configurations/{id}/outputs/{output_id} | Update a configuration output
*PluginsorggraylogpluginscollectorApi* | [**update_snippet**](docs/PluginsorggraylogpluginscollectorApi.md#update_snippet) | **PUT** /plugins/org.graylog.plugins.collector/configurations/{id}/snippets/{snippet_id} | Update a configuration snippet
*PluginsorggraylogpluginscollectorcollectorsApi* | [**get**](docs/PluginsorggraylogpluginscollectorcollectorsApi.md#get) | **GET** /plugins/org.graylog.plugins.collector/collectors/{collectorId} | Returns at most one collector summary for the specified collector id
*PluginsorggraylogpluginscollectorcollectorsApi* | [**list**](docs/PluginsorggraylogpluginscollectorcollectorsApi.md#list) | **GET** /plugins/org.graylog.plugins.collector/collectors | Lists all existing collector registrations
*PluginsorggraylogpluginscollectorcollectorsApi* | [**register**](docs/PluginsorggraylogpluginscollectorcollectorsApi.md#register) | **PUT** /plugins/org.graylog.plugins.collector/collectors/{collectorId} | Create/update a collector registration
*PluginsorggraylogpluginsmapmapdataApi* | [**map_data**](docs/PluginsorggraylogpluginsmapmapdataApi.md#map_data) | **POST** /plugins/org.graylog.plugins.map/mapdata | Get map data
*PluginsorggraylogpluginspipelineprocessorsystempipelinesconnectionsApi* | [**connect_pipelines**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinesconnectionsApi.md#connect_pipelines) | **POST** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/connections | Connect processing pipelines to a stream
*PluginsorggraylogpluginspipelineprocessorsystempipelinesconnectionsApi* | [**get_all**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinesconnectionsApi.md#get_all) | **GET** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/connections | Get all pipeline connections
*PluginsorggraylogpluginspipelineprocessorsystempipelinesconnectionsApi* | [**get_pipelines_for_stream**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinesconnectionsApi.md#get_pipelines_for_stream) | **GET** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/connections/{streamId} | Get pipeline connections for the given stream
*PluginsorggraylogpluginspipelineprocessorsystempipelinespipelineApi* | [**create_from_parser**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinespipelineApi.md#create_from_parser) | **POST** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/pipeline | Create a processing pipeline from source
*PluginsorggraylogpluginspipelineprocessorsystempipelinespipelineApi* | [**delete**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinespipelineApi.md#delete) | **DELETE** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/pipeline/{id} | Delete a processing pipeline
*PluginsorggraylogpluginspipelineprocessorsystempipelinespipelineApi* | [**get**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinespipelineApi.md#get) | **GET** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/pipeline/{id} | Get a processing pipeline
*PluginsorggraylogpluginspipelineprocessorsystempipelinespipelineApi* | [**get_all**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinespipelineApi.md#get_all) | **GET** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/pipeline | Get all processing pipelines
*PluginsorggraylogpluginspipelineprocessorsystempipelinespipelineApi* | [**parse**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinespipelineApi.md#parse) | **POST** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/pipeline/parse | Parse a processing pipeline without saving it
*PluginsorggraylogpluginspipelineprocessorsystempipelinespipelineApi* | [**update**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinespipelineApi.md#update) | **PUT** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/pipeline/{id} | Modify a processing pipeline
*PluginsorggraylogpluginspipelineprocessorsystempipelinesruleApi* | [**create_from_parser**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinesruleApi.md#create_from_parser) | **POST** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/rule | Create a processing rule from source
*PluginsorggraylogpluginspipelineprocessorsystempipelinesruleApi* | [**delete**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinesruleApi.md#delete) | **DELETE** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/rule/{id} | Delete a processing rule
*PluginsorggraylogpluginspipelineprocessorsystempipelinesruleApi* | [**function_descriptors**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinesruleApi.md#function_descriptors) | **GET** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/rule/functions | Get function descriptors
*PluginsorggraylogpluginspipelineprocessorsystempipelinesruleApi* | [**get**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinesruleApi.md#get) | **GET** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/rule/{id} | Get a processing rule
*PluginsorggraylogpluginspipelineprocessorsystempipelinesruleApi* | [**get_all**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinesruleApi.md#get_all) | **GET** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/rule | Get all processing rules
*PluginsorggraylogpluginspipelineprocessorsystempipelinesruleApi* | [**get_bulk**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinesruleApi.md#get_bulk) | **POST** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/rule/multiple | Retrieve the named processing rules in bulk
*PluginsorggraylogpluginspipelineprocessorsystempipelinesruleApi* | [**parse**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinesruleApi.md#parse) | **POST** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/rule/parse | Parse a processing rule without saving it
*PluginsorggraylogpluginspipelineprocessorsystempipelinesruleApi* | [**update**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinesruleApi.md#update) | **PUT** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/rule/{id} | Modify a processing rule
*PluginsorggraylogpluginspipelineprocessorsystempipelinessimulateApi* | [**simulate**](docs/PluginsorggraylogpluginspipelineprocessorsystempipelinessimulateApi.md#simulate) | **POST** /plugins/org.graylog.plugins.pipelineprocessor/system/pipelines/simulate | Simulate the execution of the pipeline message processor
*PluginsorggraylogpluginsusagestatisticsApi* | [**show_cluster_data_set**](docs/PluginsorggraylogpluginsusagestatisticsApi.md#show_cluster_data_set) | **GET** /plugins/org.graylog.plugins.usagestatistics/cluster | Show the collected anonymous usage statistics of this Graylog cluster
*PluginsorggraylogpluginsusagestatisticsApi* | [**show_config**](docs/PluginsorggraylogpluginsusagestatisticsApi.md#show_config) | **GET** /plugins/org.graylog.plugins.usagestatistics/config | Show configuration for the anonymous usage statistics plugin
*PluginsorggraylogpluginsusagestatisticsApi* | [**show_node_data_set**](docs/PluginsorggraylogpluginsusagestatisticsApi.md#show_node_data_set) | **GET** /plugins/org.graylog.plugins.usagestatistics/node | Show the collected anonymous usage statistics of this Graylog node
*PluginsorggraylogpluginsusagestatisticsoptoutApi* | [**get_opt_out_state**](docs/PluginsorggraylogpluginsusagestatisticsoptoutApi.md#get_opt_out_state) | **GET** /plugins/org.graylog.plugins.usagestatistics/opt-out | Get opt-out status
*PluginsorggraylogpluginsusagestatisticsoptoutApi* | [**set_opt_out_state**](docs/PluginsorggraylogpluginsusagestatisticsoptoutApi.md#set_opt_out_state) | **POST** /plugins/org.graylog.plugins.usagestatistics/opt-out | Disable sending anonymous usage stats
*RolesApi* | [**add_member**](docs/RolesApi.md#add_member) | **PUT** /roles/{rolename}/members/{username} | Add a user to a role
*RolesApi* | [**create**](docs/RolesApi.md#create) | **POST** /roles | Create a new role
*RolesApi* | [**delete**](docs/RolesApi.md#delete) | **DELETE** /roles/{rolename} | Remove the named role and dissociate any users from it
*RolesApi* | [**get_members**](docs/RolesApi.md#get_members) | **GET** /roles/{rolename}/members | Retrieve the role&#39;s members
*RolesApi* | [**list_all**](docs/RolesApi.md#list_all) | **GET** /roles | List all roles
*RolesApi* | [**read**](docs/RolesApi.md#read) | **GET** /roles/{rolename} | Retrieve permissions for a single role
*RolesApi* | [**remove_member**](docs/RolesApi.md#remove_member) | **DELETE** /roles/{rolename}/members/{username} | Remove a user from a role
*RolesApi* | [**update**](docs/RolesApi.md#update) | **PUT** /roles/{rolename} | Update an existing role
*SearchdecoratorsApi* | [**create**](docs/SearchdecoratorsApi.md#create) | **POST** /search/decorators | Creates a message decoration configuration
*SearchdecoratorsApi* | [**delete**](docs/SearchdecoratorsApi.md#delete) | **DELETE** /search/decorators/{decoratorId} | Create a decorator
*SearchdecoratorsApi* | [**get**](docs/SearchdecoratorsApi.md#get) | **GET** /search/decorators | Returns all configured message decorations
*SearchdecoratorsApi* | [**get_available**](docs/SearchdecoratorsApi.md#get_available) | **GET** /search/decorators/available | Returns all available message decorations
*SearchdecoratorsApi* | [**update**](docs/SearchdecoratorsApi.md#update) | **PUT** /search/decorators/{decoratorId} | Update a decorator
*SearchsavedApi* | [**create**](docs/SearchsavedApi.md#create) | **POST** /search/saved | Create a new saved search
*SearchsavedApi* | [**delete**](docs/SearchsavedApi.md#delete) | **DELETE** /search/saved/{searchId} | Delete a saved search
*SearchsavedApi* | [**get**](docs/SearchsavedApi.md#get) | **GET** /search/saved/{searchId} | Get a single saved search
*SearchsavedApi* | [**list**](docs/SearchsavedApi.md#list) | **GET** /search/saved | Get a list of all saved searches
*SearchsavedApi* | [**update**](docs/SearchsavedApi.md#update) | **PUT** /search/saved/{searchId} | Update a saved search
*SearchuniversalabsoluteApi* | [**export_search_absolute_chunked**](docs/SearchuniversalabsoluteApi.md#export_search_absolute_chunked) | **GET** /search/universal/absolute/export | Export message search with absolute timerange.
*SearchuniversalabsoluteApi* | [**field_histogram_absolute**](docs/SearchuniversalabsoluteApi.md#field_histogram_absolute) | **GET** /search/universal/absolute/fieldhistogram | Field value histogram of a query using an absolute timerange.
*SearchuniversalabsoluteApi* | [**histogram_absolute**](docs/SearchuniversalabsoluteApi.md#histogram_absolute) | **GET** /search/universal/absolute/histogram | Datetime histogram of a query using an absolute timerange.
*SearchuniversalabsoluteApi* | [**search_absolute**](docs/SearchuniversalabsoluteApi.md#search_absolute) | **GET** /search/universal/absolute | Message search with absolute timerange.
*SearchuniversalabsoluteApi* | [**stats_absolute**](docs/SearchuniversalabsoluteApi.md#stats_absolute) | **GET** /search/universal/absolute/stats | Field statistics for a query using an absolute timerange.
*SearchuniversalabsoluteApi* | [**terms_absolute**](docs/SearchuniversalabsoluteApi.md#terms_absolute) | **GET** /search/universal/absolute/terms | Most common field terms of a query using an absolute timerange.
*SearchuniversalabsoluteApi* | [**terms_stats_absolute**](docs/SearchuniversalabsoluteApi.md#terms_stats_absolute) | **GET** /search/universal/absolute/termsstats | Ordered field terms of a query computed on another field using an absolute timerange.
*SearchuniversalkeywordApi* | [**export_search_keyword_chunked**](docs/SearchuniversalkeywordApi.md#export_search_keyword_chunked) | **GET** /search/universal/keyword/export | Export message search with keyword as timerange.
*SearchuniversalkeywordApi* | [**field_histogram_keyword**](docs/SearchuniversalkeywordApi.md#field_histogram_keyword) | **GET** /search/universal/keyword/fieldhistogram | Datetime histogram of a query using keyword timerange.
*SearchuniversalkeywordApi* | [**histogram_keyword**](docs/SearchuniversalkeywordApi.md#histogram_keyword) | **GET** /search/universal/keyword/histogram | Datetime histogram of a query using keyword timerange.
*SearchuniversalkeywordApi* | [**search_keyword**](docs/SearchuniversalkeywordApi.md#search_keyword) | **GET** /search/universal/keyword | Message search with keyword as timerange.
*SearchuniversalkeywordApi* | [**stats_keyword**](docs/SearchuniversalkeywordApi.md#stats_keyword) | **GET** /search/universal/keyword/stats | Field statistics for a query using a keyword timerange.
*SearchuniversalkeywordApi* | [**terms_keyword**](docs/SearchuniversalkeywordApi.md#terms_keyword) | **GET** /search/universal/keyword/terms | Most common field terms of a query using a keyword timerange.
*SearchuniversalkeywordApi* | [**terms_stats_relative**](docs/SearchuniversalkeywordApi.md#terms_stats_relative) | **GET** /search/universal/keyword/termsstats | Ordered field terms of a query computed on another field using a keyword timerange.
*SearchuniversalrelativeApi* | [**export_search_relative_chunked**](docs/SearchuniversalrelativeApi.md#export_search_relative_chunked) | **GET** /search/universal/relative/export | Export message search with relative timerange.
*SearchuniversalrelativeApi* | [**field_histogram_relative**](docs/SearchuniversalrelativeApi.md#field_histogram_relative) | **GET** /search/universal/relative/fieldhistogram | Field value histogram of a query using a relative timerange.
*SearchuniversalrelativeApi* | [**histogram_relative**](docs/SearchuniversalrelativeApi.md#histogram_relative) | **GET** /search/universal/relative/histogram | Datetime histogram of a query using a relative timerange.
*SearchuniversalrelativeApi* | [**search_relative**](docs/SearchuniversalrelativeApi.md#search_relative) | **GET** /search/universal/relative | Message search with relative timerange.
*SearchuniversalrelativeApi* | [**stats_relative**](docs/SearchuniversalrelativeApi.md#stats_relative) | **GET** /search/universal/relative/stats | Field statistics for a query using a relative timerange.
*SearchuniversalrelativeApi* | [**terms_relative**](docs/SearchuniversalrelativeApi.md#terms_relative) | **GET** /search/universal/relative/terms | Most common field terms of a query using a relative timerange.
*SearchuniversalrelativeApi* | [**terms_stats_relative**](docs/SearchuniversalrelativeApi.md#terms_stats_relative) | **GET** /search/universal/relative/termsstats | Ordered field terms of a query computed on another field using a relative timerange.
*SourcesApi* | [**list**](docs/SourcesApi.md#list) | **GET** /sources | Get a list of all sources (not more than 5000) that have messages in the current indices. The result is cached for 10 seconds.
*StreamsApi* | [**clone_stream**](docs/StreamsApi.md#clone_stream) | **POST** /streams/{streamId}/clone | Clone a stream
*StreamsApi* | [**create**](docs/StreamsApi.md#create) | **POST** /streams | Create a stream
*StreamsApi* | [**delete**](docs/StreamsApi.md#delete) | **DELETE** /streams/{streamId} | Delete a stream
*StreamsApi* | [**get**](docs/StreamsApi.md#get) | **GET** /streams | Get a list of all streams
*StreamsApi* | [**get_0**](docs/StreamsApi.md#get_0) | **GET** /streams/{streamId} | Get a single stream
*StreamsApi* | [**get_enabled**](docs/StreamsApi.md#get_enabled) | **GET** /streams/enabled | Get a list of all enabled streams
*StreamsApi* | [**pause**](docs/StreamsApi.md#pause) | **POST** /streams/{streamId}/pause | Pause a stream
*StreamsApi* | [**resume**](docs/StreamsApi.md#resume) | **POST** /streams/{streamId}/resume | Resume a stream
*StreamsApi* | [**test_match**](docs/StreamsApi.md#test_match) | **POST** /streams/{streamId}/testMatch | Test matching of a stream against a supplied message
*StreamsApi* | [**update**](docs/StreamsApi.md#update) | **PUT** /streams/{streamId} | Update a stream
*StreamsalertsApi* | [**list_all**](docs/StreamsalertsApi.md#list_all) | **GET** /streams/alerts | Get the 300 most recent alarms of all streams.
*SystemApi* | [**jvm**](docs/SystemApi.md#jvm) | **GET** /system/jvm | Get JVM information
*SystemApi* | [**system**](docs/SystemApi.md#system) | **GET** /system | Get system overview
*SystemApi* | [**threaddump**](docs/SystemApi.md#threaddump) | **GET** /system/threaddump | Get a thread dump
*SystemauthenticationApi* | [**create**](docs/SystemauthenticationApi.md#create) | **PUT** /system/authentication/config | Update authentication providers configuration
*SystemauthenticationApi* | [**get_authenticators**](docs/SystemauthenticationApi.md#get_authenticators) | **GET** /system/authentication/config | Retrieve authentication providers configuration
*SystembundlesApi* | [**apply_bundle**](docs/SystembundlesApi.md#apply_bundle) | **POST** /system/bundles/{bundleId}/apply | Set up entities described by content pack
*SystembundlesApi* | [**create_bundle**](docs/SystembundlesApi.md#create_bundle) | **POST** /system/bundles | Upload a content pack
*SystembundlesApi* | [**delete_bundle**](docs/SystembundlesApi.md#delete_bundle) | **DELETE** /system/bundles/{bundleId} | Delete content pack
*SystembundlesApi* | [**export_bundle**](docs/SystembundlesApi.md#export_bundle) | **POST** /system/bundles/export | Export entities as a content pack
*SystembundlesApi* | [**list_bundles**](docs/SystembundlesApi.md#list_bundles) | **GET** /system/bundles | List available content packs
*SystembundlesApi* | [**show_bundle**](docs/SystembundlesApi.md#show_bundle) | **GET** /system/bundles/{bundleId} | Show content pack
*SystembundlesApi* | [**update_bundle**](docs/SystembundlesApi.md#update_bundle) | **PUT** /system/bundles/{bundleId} | Update content pack
*SystemclusterApi* | [**node**](docs/SystemclusterApi.md#node) | **GET** /system/cluster/node | Information about this node.
*SystemclusterApi* | [**node_0**](docs/SystemclusterApi.md#node_0) | **GET** /system/cluster/nodes/{nodeId} | Information about a node.
*SystemclusterApi* | [**nodes**](docs/SystemclusterApi.md#nodes) | **GET** /system/cluster/nodes | List all active nodes in this cluster.
*SystemclusterconfigApi* | [**delete**](docs/SystemclusterconfigApi.md#delete) | **DELETE** /system/cluster_config/{configClass} | Delete configuration settings from database
*SystemclusterconfigApi* | [**list**](docs/SystemclusterconfigApi.md#list) | **GET** /system/cluster_config | List all configuration classes
*SystemclusterconfigApi* | [**schema**](docs/SystemclusterconfigApi.md#schema) | **GET** /system/cluster_config/{configClass} | Get JSON schema of configuration class
*SystemclusterconfigApi* | [**update**](docs/SystemclusterconfigApi.md#update) | **PUT** /system/cluster_config/{configClass} | Update configuration in database
*SystemclusterstatsApi* | [**elasticsearch_stats**](docs/SystemclusterstatsApi.md#elasticsearch_stats) | **GET** /system/cluster/stats/elasticsearch | Elasticsearch information.
*SystemclusterstatsApi* | [**mongo_stats**](docs/SystemclusterstatsApi.md#mongo_stats) | **GET** /system/cluster/stats/mongo | MongoDB information.
*SystemclusterstatsApi* | [**system_stats**](docs/SystemclusterstatsApi.md#system_stats) | **GET** /system/cluster/stats | Cluster status information.
*SystemcodecstypesApi* | [**get_all**](docs/SystemcodecstypesApi.md#get_all) | **GET** /system/codecs/types/all | Get all codec types
*SystemconfigurationApi* | [**get_relevant**](docs/SystemconfigurationApi.md#get_relevant) | **GET** /system/configuration | Get relevant configuration settings and their values
*SystemdebugeventsApi* | [**generate_cluster_debug_event**](docs/SystemdebugeventsApi.md#generate_cluster_debug_event) | **POST** /system/debug/events/cluster | Create and send a cluster debug event.
*SystemdebugeventsApi* | [**generate_debug_event**](docs/SystemdebugeventsApi.md#generate_debug_event) | **POST** /system/debug/events/local | Create and send a local debug event.
*SystemdebugeventsApi* | [**show_last_cluster_debug_event**](docs/SystemdebugeventsApi.md#show_last_cluster_debug_event) | **GET** /system/debug/events/cluster | Show last received cluster debug event.
*SystemdebugeventsApi* | [**show_last_debug_event**](docs/SystemdebugeventsApi.md#show_last_debug_event) | **GET** /system/debug/events/local | Show last received local debug event.
*SystemdeflectorApi* | [**cycle**](docs/SystemdeflectorApi.md#cycle) | **POST** /system/deflector/cycle | Cycle deflector to new/next index
*SystemdeflectorApi* | [**deflector**](docs/SystemdeflectorApi.md#deflector) | **GET** /system/deflector | Get current deflector status
*SystemfieldsApi* | [**fields**](docs/SystemfieldsApi.md#fields) | **GET** /system/fields | Get list of message fields that exist
*SystemgettingstartedApi* | [**dismiss_getting_started**](docs/SystemgettingstartedApi.md#dismiss_getting_started) | **POST** /system/gettingstarted/dismiss | Dismiss auto-showing getting started guide for this version
*SystemgettingstartedApi* | [**display_getting_started**](docs/SystemgettingstartedApi.md#display_getting_started) | **GET** /system/gettingstarted | Check whether to display the Getting started guide for this version
*SystemgrokApi* | [**bulk_update_patterns**](docs/SystemgrokApi.md#bulk_update_patterns) | **PUT** /system/grok | Add a list of new patterns
*SystemgrokApi* | [**create_pattern**](docs/SystemgrokApi.md#create_pattern) | **POST** /system/grok | Add a new named pattern
*SystemgrokApi* | [**list_grok_patterns**](docs/SystemgrokApi.md#list_grok_patterns) | **GET** /system/grok | Get all existing grok patterns
*SystemgrokApi* | [**list_pattern**](docs/SystemgrokApi.md#list_pattern) | **GET** /system/grok/{patternId} | Get the existing grok pattern
*SystemgrokApi* | [**remove_pattern**](docs/SystemgrokApi.md#remove_pattern) | **DELETE** /system/grok/{patternId} | Remove an existing pattern by id
*SystemgrokApi* | [**update_pattern**](docs/SystemgrokApi.md#update_pattern) | **PUT** /system/grok/{patternId} | Update an existing pattern
*SystemindexerclusterApi* | [**cluster_health**](docs/SystemindexerclusterApi.md#cluster_health) | **GET** /system/indexer/cluster/health | Get cluster and shard health overview
*SystemindexerclusterApi* | [**cluster_name**](docs/SystemindexerclusterApi.md#cluster_name) | **GET** /system/indexer/cluster/name | Get the cluster name
*SystemindexerfailuresApi* | [**count**](docs/SystemindexerfailuresApi.md#count) | **GET** /system/indexer/failures/count | Total count of failed index operations since the given date.
*SystemindexerfailuresApi* | [**single**](docs/SystemindexerfailuresApi.md#single) | **GET** /system/indexer/failures | Get a list of failed index operations.
*SystemindexerindicesApi* | [**all**](docs/SystemindexerindicesApi.md#all) | **GET** /system/indexer/indices | List all open, closed and reopened indices.
*SystemindexerindicesApi* | [**close**](docs/SystemindexerindicesApi.md#close) | **POST** /system/indexer/indices/{index}/close | Close an index. This will also trigger an index ranges rebuild job.
*SystemindexerindicesApi* | [**closed**](docs/SystemindexerindicesApi.md#closed) | **GET** /system/indexer/indices/closed | Get a list of closed indices that can be reopened.
*SystemindexerindicesApi* | [**delete**](docs/SystemindexerindicesApi.md#delete) | **DELETE** /system/indexer/indices/{index} | Delete an index. This will also trigger an index ranges rebuild job.
*SystemindexerindicesApi* | [**multiple**](docs/SystemindexerindicesApi.md#multiple) | **POST** /system/indexer/indices/multiple | Get information of all specified indices and their shards.
*SystemindexerindicesApi* | [**open**](docs/SystemindexerindicesApi.md#open) | **GET** /system/indexer/indices/open | Get information of all open indices managed by Graylog and their shards.
*SystemindexerindicesApi* | [**reopen**](docs/SystemindexerindicesApi.md#reopen) | **POST** /system/indexer/indices/{index}/reopen | Reopen a closed index. This will also trigger an index ranges rebuild job.
*SystemindexerindicesApi* | [**reopened**](docs/SystemindexerindicesApi.md#reopened) | **GET** /system/indexer/indices/reopened | Get a list of reopened indices, which will not be cleaned by retention cleaning
*SystemindexerindicesApi* | [**single**](docs/SystemindexerindicesApi.md#single) | **GET** /system/indexer/indices/{index} | Get information of an index and its shards.
*SystemindexeroverviewApi* | [**index**](docs/SystemindexeroverviewApi.md#index) | **GET** /system/indexer/overview | Get overview of current indexing state, including deflector config, cluster state, index ranges &amp; message counts.
*SystemindicesrangesApi* | [**list**](docs/SystemindicesrangesApi.md#list) | **GET** /system/indices/ranges | Get a list of all index ranges
*SystemindicesrangesApi* | [**rebuild**](docs/SystemindicesrangesApi.md#rebuild) | **POST** /system/indices/ranges/rebuild | Rebuild/sync index range information.
*SystemindicesrangesApi* | [**rebuild_index**](docs/SystemindicesrangesApi.md#rebuild_index) | **POST** /system/indices/ranges/{index: [a-z_0-9]+}/rebuild | Rebuild/sync index range information.
*SystemindicesrangesApi* | [**show**](docs/SystemindicesrangesApi.md#show) | **GET** /system/indices/ranges/{index: [a-z_0-9]+} | Show single index range
*SystemindicesretentionApi* | [**config**](docs/SystemindicesretentionApi.md#config) | **GET** /system/indices/retention/config | Configuration of the current retention strategy
*SystemindicesretentionApi* | [**config_0**](docs/SystemindicesretentionApi.md#config_0) | **PUT** /system/indices/retention/config | Configuration of the current retention strategy
*SystemindicesretentionApi* | [**config_schema**](docs/SystemindicesretentionApi.md#config_schema) | **GET** /system/indices/retention/strategies/{strategy} | Show JSON schema for configuration of given retention strategies
*SystemindicesretentionApi* | [**list**](docs/SystemindicesretentionApi.md#list) | **GET** /system/indices/retention/strategies | List available retention strategies
*SystemindicesrotationApi* | [**config**](docs/SystemindicesrotationApi.md#config) | **GET** /system/indices/rotation/config | Configuration of the current rotation strategy
*SystemindicesrotationApi* | [**config_0**](docs/SystemindicesrotationApi.md#config_0) | **PUT** /system/indices/rotation/config | Configuration of the current rotation strategy
*SystemindicesrotationApi* | [**config_schema**](docs/SystemindicesrotationApi.md#config_schema) | **GET** /system/indices/rotation/strategies/{strategy} | Show JSON schema for configuration of given rotation strategies
*SystemindicesrotationApi* | [**list**](docs/SystemindicesrotationApi.md#list) | **GET** /system/indices/rotation/strategies | List available rotation strategies
*SysteminputsApi* | [**create**](docs/SysteminputsApi.md#create) | **POST** /system/inputs | Launch input on this node
*SysteminputsApi* | [**get**](docs/SysteminputsApi.md#get) | **GET** /system/inputs/{inputId} | Get information of a single input on this node
*SysteminputsApi* | [**list**](docs/SysteminputsApi.md#list) | **GET** /system/inputs | Get all inputs
*SysteminputsApi* | [**terminate**](docs/SysteminputsApi.md#terminate) | **DELETE** /system/inputs/{inputId} | Terminate input on this node
*SysteminputsApi* | [**update**](docs/SysteminputsApi.md#update) | **PUT** /system/inputs/{inputId} | Update input on this node
*SysteminputstatesApi* | [**get**](docs/SysteminputstatesApi.md#get) | **GET** /system/inputstates/{inputId} | Get input state for specified input id on this node
*SysteminputstatesApi* | [**list**](docs/SysteminputstatesApi.md#list) | **GET** /system/inputstates | Get all input states of this node
*SysteminputstatesApi* | [**start**](docs/SysteminputstatesApi.md#start) | **PUT** /system/inputstates/{inputId} | (Re-)Start specified input on this node
*SysteminputstatesApi* | [**stop**](docs/SysteminputstatesApi.md#stop) | **DELETE** /system/inputstates/{inputId} | Stop specified input on this node
*SysteminputstypesApi* | [**all**](docs/SysteminputstypesApi.md#all) | **GET** /system/inputs/types/all | Get information about all input types
*SysteminputstypesApi* | [**info**](docs/SysteminputstypesApi.md#info) | **GET** /system/inputs/types/{inputType} | Get information about a single input type
*SysteminputstypesApi* | [**types**](docs/SysteminputstypesApi.md#types) | **GET** /system/inputs/types | Get all available input types of this node
*SystemjobsApi* | [**cancel**](docs/SystemjobsApi.md#cancel) | **DELETE** /system/jobs/{jobId} | Cancel running job
*SystemjobsApi* | [**get**](docs/SystemjobsApi.md#get) | **GET** /system/jobs/{jobId} | Get information of a specific currently running job
*SystemjobsApi* | [**list**](docs/SystemjobsApi.md#list) | **GET** /system/jobs | List currently running jobs
*SystemjobsApi* | [**trigger**](docs/SystemjobsApi.md#trigger) | **POST** /system/jobs | Trigger new job
*SystemjournalApi* | [**show**](docs/SystemjournalApi.md#show) | **GET** /system/journal | Get current state of the journal on this node.
*SystemlbstatusApi* | [**override**](docs/SystemlbstatusApi.md#override) | **PUT** /system/lbstatus/override/{status} | Override load balancer status of this Graylog server node. Next lifecycle change will override it again to its default. Set to ALIVE, DEAD, or THROTTLED.
*SystemlbstatusApi* | [**status**](docs/SystemlbstatusApi.md#status) | **GET** /system/lbstatus | Get status of this Graylog server node for load balancers. Returns ALIVE with HTTP 200, DEAD with HTTP 503, or THROTTLED with HTTP 429.
*SystemldapApi* | [**delete_ldap_settings**](docs/SystemldapApi.md#delete_ldap_settings) | **DELETE** /system/ldap/settings | Remove the LDAP configuration
*SystemldapApi* | [**get_ldap_settings**](docs/SystemldapApi.md#get_ldap_settings) | **GET** /system/ldap/settings | Get the LDAP configuration if it is configured
*SystemldapApi* | [**read_group_mapping**](docs/SystemldapApi.md#read_group_mapping) | **GET** /system/ldap/settings/groups | Get the LDAP group to Graylog role mapping
*SystemldapApi* | [**read_groups**](docs/SystemldapApi.md#read_groups) | **GET** /system/ldap/groups | Get the available LDAP groups
*SystemldapApi* | [**test_ldap_configuration**](docs/SystemldapApi.md#test_ldap_configuration) | **POST** /system/ldap/test | Test LDAP Configuration
*SystemldapApi* | [**update_group_mapping_settings**](docs/SystemldapApi.md#update_group_mapping_settings) | **PUT** /system/ldap/settings/groups | Update the LDAP group to Graylog role mapping
*SystemldapApi* | [**update_ldap_settings**](docs/SystemldapApi.md#update_ldap_settings) | **PUT** /system/ldap/settings | Update the LDAP configuration
*SystemloggersApi* | [**loggers**](docs/SystemloggersApi.md#loggers) | **GET** /system/loggers | List all loggers and their current levels
*SystemloggersApi* | [**messages**](docs/SystemloggersApi.md#messages) | **GET** /system/loggers/messages/recent | Get recent internal log messages
*SystemloggersApi* | [**set_single_logger_level**](docs/SystemloggersApi.md#set_single_logger_level) | **PUT** /system/loggers/{loggerName}/level/{level} | Set the loglevel of a single logger
*SystemloggersApi* | [**set_subsystem_logger_level**](docs/SystemloggersApi.md#set_subsystem_logger_level) | **PUT** /system/loggers/subsystems/{subsystem}/level/{level} | Set the loglevel of a whole subsystem
*SystemloggersApi* | [**subsystems**](docs/SystemloggersApi.md#subsystems) | **GET** /system/loggers/subsystems | List all logger subsystems and their current levels
*SystemmessageprocessorsApi* | [**config**](docs/SystemmessageprocessorsApi.md#config) | **GET** /system/messageprocessors/config | Get message processor configuration
*SystemmessageprocessorsApi* | [**update_config**](docs/SystemmessageprocessorsApi.md#update_config) | **PUT** /system/messageprocessors/config | Update message processor configuration
*SystemmessagesApi* | [**all**](docs/SystemmessagesApi.md#all) | **GET** /system/messages | Get internal Graylog system messages
*SystemmetricsApi* | [**by_namespace**](docs/SystemmetricsApi.md#by_namespace) | **GET** /system/metrics/namespace/{namespace} | Get all metrics of a namespace
*SystemmetricsApi* | [**metric_names**](docs/SystemmetricsApi.md#metric_names) | **GET** /system/metrics/names | Get all metrics keys/names
*SystemmetricsApi* | [**metrics**](docs/SystemmetricsApi.md#metrics) | **GET** /system/metrics | Get all metrics
*SystemmetricsApi* | [**multiple_metrics**](docs/SystemmetricsApi.md#multiple_metrics) | **POST** /system/metrics/multiple | Get the values of multiple metrics at once
*SystemmetricsApi* | [**single_metric**](docs/SystemmetricsApi.md#single_metric) | **GET** /system/metrics/{metricName} | Get a single metric
*SystemnotificationsApi* | [**delete_notification**](docs/SystemnotificationsApi.md#delete_notification) | **DELETE** /system/notifications/{notificationType} | Delete a notification
*SystemnotificationsApi* | [**list_notifications**](docs/SystemnotificationsApi.md#list_notifications) | **GET** /system/notifications | Get all active notifications
*SystemoutputsApi* | [**available**](docs/SystemoutputsApi.md#available) | **GET** /system/outputs/available | Get all available output modules
*SystemoutputsApi* | [**create**](docs/SystemoutputsApi.md#create) | **POST** /system/outputs | Create an output
*SystemoutputsApi* | [**delete**](docs/SystemoutputsApi.md#delete) | **DELETE** /system/outputs/{outputId} | Delete output
*SystemoutputsApi* | [**get**](docs/SystemoutputsApi.md#get) | **GET** /system/outputs | Get a list of all outputs
*SystemoutputsApi* | [**get_0**](docs/SystemoutputsApi.md#get_0) | **GET** /system/outputs/{outputId} | Get specific output
*SystemoutputsApi* | [**update**](docs/SystemoutputsApi.md#update) | **PUT** /system/outputs/{outputId} | Update output
*SystempermissionsApi* | [**permissions**](docs/SystempermissionsApi.md#permissions) | **GET** /system/permissions | Get all available user permissions.
*SystempermissionsApi* | [**reader_permissions**](docs/SystempermissionsApi.md#reader_permissions) | **GET** /system/permissions/reader/{username} | Get the initial permissions assigned to a reader account
*SystempluginsApi* | [**list**](docs/SystempluginsApi.md#list) | **GET** /system/plugins | List all installed plugins on this node.
*SystemprocessingApi* | [**pause_processing**](docs/SystemprocessingApi.md#pause_processing) | **PUT** /system/processing/pause | Pauses message processing
*SystemprocessingApi* | [**resume_processing**](docs/SystemprocessingApi.md#resume_processing) | **PUT** /system/processing/resume | Resume message processing
*SystemserviceManagerApi* | [**list**](docs/SystemserviceManagerApi.md#list) | **GET** /system/serviceManager | List current status of ServiceManager
*SystemsessionsApi* | [**new_session**](docs/SystemsessionsApi.md#new_session) | **POST** /system/sessions | Create a new session
*SystemsessionsApi* | [**terminate_session**](docs/SystemsessionsApi.md#terminate_session) | **DELETE** /system/sessions/{sessionId} | Terminate an existing session
*SystemsessionsApi* | [**validate_session**](docs/SystemsessionsApi.md#validate_session) | **GET** /system/sessions | Validate an existing session
*SystemshutdownApi* | [**shutdown**](docs/SystemshutdownApi.md#shutdown) | **POST** /system/shutdown/shutdown | Shutdown this node gracefully.
*SystemstatsApi* | [**fs_stats**](docs/SystemstatsApi.md#fs_stats) | **GET** /system/stats/fs | Filesystem information about this node.
*SystemstatsApi* | [**jvm_stats**](docs/SystemstatsApi.md#jvm_stats) | **GET** /system/stats/jvm | JVM information about this node.
*SystemstatsApi* | [**network_stats**](docs/SystemstatsApi.md#network_stats) | **GET** /system/stats/network | Networking information about this node.
*SystemstatsApi* | [**os_stats**](docs/SystemstatsApi.md#os_stats) | **GET** /system/stats/os | OS information about this node.
*SystemstatsApi* | [**process_stats**](docs/SystemstatsApi.md#process_stats) | **GET** /system/stats/process | Process information about this node.
*SystemstatsApi* | [**system_stats**](docs/SystemstatsApi.md#system_stats) | **GET** /system/stats | System information about this node.
*SystemthroughputApi* | [**total**](docs/SystemthroughputApi.md#total) | **GET** /system/throughput | Current throughput of this node in messages per second
*UsersApi* | [**change_password**](docs/UsersApi.md#change_password) | **PUT** /users/{username}/password | Update the password for a user.
*UsersApi* | [**change_user**](docs/UsersApi.md#change_user) | **PUT** /users/{username} | Modify user details.
*UsersApi* | [**create**](docs/UsersApi.md#create) | **POST** /users | Create a new user account.
*UsersApi* | [**delete_permissions**](docs/UsersApi.md#delete_permissions) | **DELETE** /users/{username}/permissions | Revoke all permissions for a user without deleting the account.
*UsersApi* | [**delete_user**](docs/UsersApi.md#delete_user) | **DELETE** /users/{username} | Removes a user account.
*UsersApi* | [**edit_permissions**](docs/UsersApi.md#edit_permissions) | **PUT** /users/{username}/permissions | Update a user&#39;s permission set.
*UsersApi* | [**generate_new_token**](docs/UsersApi.md#generate_new_token) | **POST** /users/{username}/tokens/{name} | Generates a new access token for a user
*UsersApi* | [**get**](docs/UsersApi.md#get) | **GET** /users/{username} | Get user details
*UsersApi* | [**list_tokens**](docs/UsersApi.md#list_tokens) | **GET** /users/{username}/tokens | Retrieves the list of access tokens for a user
*UsersApi* | [**list_users**](docs/UsersApi.md#list_users) | **GET** /users | List all users
*UsersApi* | [**revoke_token**](docs/UsersApi.md#revoke_token) | **DELETE** /users/{username}/tokens/{token} | Removes a token for a user
*UsersApi* | [**save_preferences**](docs/UsersApi.md#save_preferences) | **PUT** /users/{username}/preferences | Update a user&#39;s preferences set.


## Documentation For Models

 - [AlertListSummary](docs/AlertListSummary.md)
 - [AllIndices](docs/AllIndices.md)
 - [BulkRuleRequest](docs/BulkRuleRequest.md)
 - [ChangePasswordRequest](docs/ChangePasswordRequest.md)
 - [ChangeUserRequest](docs/ChangeUserRequest.md)
 - [CloneStreamRequest](docs/CloneStreamRequest.md)
 - [ClosedIndices](docs/ClosedIndices.md)
 - [ClusterConfigList](docs/ClusterConfigList.md)
 - [ClusterDataSet](docs/ClusterDataSet.md)
 - [ClusterHealth](docs/ClusterHealth.md)
 - [ClusterName](docs/ClusterName.md)
 - [ClusterStats](docs/ClusterStats.md)
 - [CollectorList](docs/CollectorList.md)
 - [CollectorRegistrationRequest](docs/CollectorRegistrationRequest.md)
 - [CollectorSummary](docs/CollectorSummary.md)
 - [ConfigurationBundle](docs/ConfigurationBundle.md)
 - [CreateDashboardRequest](docs/CreateDashboardRequest.md)
 - [CreateOutputRequest](docs/CreateOutputRequest.md)
 - [CreateSavedSearchRequest](docs/CreateSavedSearchRequest.md)
 - [CreateStreamRequest](docs/CreateStreamRequest.md)
 - [CreateUserRequest](docs/CreateUserRequest.md)
 - [DashboardList](docs/DashboardList.md)
 - [DebugEvent](docs/DebugEvent.md)
 - [DecoratorImpl](docs/DecoratorImpl.md)
 - [DeflectorSummary](docs/DeflectorSummary.md)
 - [DisplayGettingStarted](docs/DisplayGettingStarted.md)
 - [ElasticsearchStats](docs/ElasticsearchStats.md)
 - [ExportBundle](docs/ExportBundle.md)
 - [ExposedConfiguration](docs/ExposedConfiguration.md)
 - [FailureCount](docs/FailureCount.md)
 - [FieldStatsResult](docs/FieldStatsResult.md)
 - [FilterDescription](docs/FilterDescription.md)
 - [FsStats](docs/FsStats.md)
 - [GrokPattern](docs/GrokPattern.md)
 - [GrokPatternList](docs/GrokPatternList.md)
 - [GrokPatternSummary](docs/GrokPatternSummary.md)
 - [HistogramResult](docs/HistogramResult.md)
 - [IndexInfo](docs/IndexInfo.md)
 - [IndexRangeSummary](docs/IndexRangeSummary.md)
 - [IndexRangesResponse](docs/IndexRangesResponse.md)
 - [IndexerOverview](docs/IndexerOverview.md)
 - [IndicesReadRequest](docs/IndicesReadRequest.md)
 - [InputCreateRequest](docs/InputCreateRequest.md)
 - [InputCreated](docs/InputCreated.md)
 - [InputDeleted](docs/InputDeleted.md)
 - [InputStateSummary](docs/InputStateSummary.md)
 - [InputStatesList](docs/InputStatesList.md)
 - [InputSummary](docs/InputSummary.md)
 - [InputTypeInfo](docs/InputTypeInfo.md)
 - [InputTypesSummary](docs/InputTypesSummary.md)
 - [InputsList](docs/InputsList.md)
 - [JournalSummaryResponse](docs/JournalSummaryResponse.md)
 - [JvmStats](docs/JvmStats.md)
 - [LdapSettingsRequest](docs/LdapSettingsRequest.md)
 - [LdapSettingsResponse](docs/LdapSettingsResponse.md)
 - [LdapTestConfigRequest](docs/LdapTestConfigRequest.md)
 - [LdapTestConfigResponse](docs/LdapTestConfigResponse.md)
 - [LogMessagesSummary](docs/LogMessagesSummary.md)
 - [LoggersSummary](docs/LoggersSummary.md)
 - [MapDataSearchRequest](docs/MapDataSearchRequest.md)
 - [MapDataSearchResult](docs/MapDataSearchResult.md)
 - [MessageCountResponse](docs/MessageCountResponse.md)
 - [MessageParseRequest](docs/MessageParseRequest.md)
 - [MessageProcessorsConfigWithDescriptors](docs/MessageProcessorsConfigWithDescriptors.md)
 - [MessageTokens](docs/MessageTokens.md)
 - [MetricNamesResponse](docs/MetricNamesResponse.md)
 - [MetricsReadRequest](docs/MetricsReadRequest.md)
 - [MetricsSummaryResponse](docs/MetricsSummaryResponse.md)
 - [MongoStats](docs/MongoStats.md)
 - [NetworkStats](docs/NetworkStats.md)
 - [NodeDataSet](docs/NodeDataSet.md)
 - [NodeSummary](docs/NodeSummary.md)
 - [NodeSummaryList](docs/NodeSummaryList.md)
 - [OpenIndicesInfo](docs/OpenIndicesInfo.md)
 - [OsStats](docs/OsStats.md)
 - [Output](docs/Output.md)
 - [OutputListResponse](docs/OutputListResponse.md)
 - [OutputSummary](docs/OutputSummary.md)
 - [PermissionEditRequest](docs/PermissionEditRequest.md)
 - [PipelineConnections](docs/PipelineConnections.md)
 - [PipelineSource](docs/PipelineSource.md)
 - [PluginList](docs/PluginList.md)
 - [ProcessStats](docs/ProcessStats.md)
 - [ReaderPermissionResponse](docs/ReaderPermissionResponse.md)
 - [RetentionStrategies](docs/RetentionStrategies.md)
 - [RetentionStrategyDescription](docs/RetentionStrategyDescription.md)
 - [RetentionStrategySummary](docs/RetentionStrategySummary.md)
 - [RoleMembershipResponse](docs/RoleMembershipResponse.md)
 - [RoleResponse](docs/RoleResponse.md)
 - [RolesResponse](docs/RolesResponse.md)
 - [RotationStrategies](docs/RotationStrategies.md)
 - [RotationStrategyDescription](docs/RotationStrategyDescription.md)
 - [RotationStrategySummary](docs/RotationStrategySummary.md)
 - [RuleSource](docs/RuleSource.md)
 - [SearchResponse](docs/SearchResponse.md)
 - [SessionCreateRequest](docs/SessionCreateRequest.md)
 - [SessionResponse](docs/SessionResponse.md)
 - [SessionValidationResponse](docs/SessionValidationResponse.md)
 - [SimulationRequest](docs/SimulationRequest.md)
 - [SimulationResponse](docs/SimulationResponse.md)
 - [SourcesList](docs/SourcesList.md)
 - [StreamListResponse](docs/StreamListResponse.md)
 - [StreamResponse](docs/StreamResponse.md)
 - [SubsystemSummary](docs/SubsystemSummary.md)
 - [SystemJVMResponse](docs/SystemJVMResponse.md)
 - [SystemJobSummary](docs/SystemJobSummary.md)
 - [SystemOverviewResponse](docs/SystemOverviewResponse.md)
 - [SystemStats](docs/SystemStats.md)
 - [SystemThreadDumpResponse](docs/SystemThreadDumpResponse.md)
 - [TermsResult](docs/TermsResult.md)
 - [TermsStatsResult](docs/TermsStatsResult.md)
 - [TestMatchResponse](docs/TestMatchResponse.md)
 - [Throughput](docs/Throughput.md)
 - [Token](docs/Token.md)
 - [TokenList](docs/TokenList.md)
 - [TriggerRequest](docs/TriggerRequest.md)
 - [UpdateDashboardRequest](docs/UpdateDashboardRequest.md)
 - [UpdateStreamRequest](docs/UpdateStreamRequest.md)
 - [UpdateUserPreferences](docs/UpdateUserPreferences.md)
 - [UsageStatsConfigurationResponse](docs/UsageStatsConfigurationResponse.md)
 - [UsageStatsOptOutState](docs/UsageStatsOptOutState.md)
 - [UserList](docs/UserList.md)
 - [UserSummary](docs/UserSummary.md)
 - [WidgetPositionsRequest](docs/WidgetPositionsRequest.md)


## Documentation For Authorization

 All endpoints do not require authorization.


## Author



